#!/bin/sh
# Don't run this set -e, or it will crash on missing or already-mounted devices
sudo mkdir -p /mnt/keys1
sudo mkdir -p /mnt/keys2
sudo mkdir -p /mnt/keys3
sudo mkdir -p /mnt/transfer
sudo mount -L keys1 -o noexec,uid=1000,umask=0077 /mnt/keys1 2>/dev/null || sudo rmdir /mnt/keys1 2>/dev/null
sudo mount -L keys2 -o noexec,uid=1000,umask=0077 /mnt/keys2 2>/dev/null || sudo rmdir /mnt/keys2 2>/dev/null
sudo mount -L keys3 -o noexec,uid=1000,umask=0077 /mnt/keys3 2>/dev/null || sudo rmdir /mnt/keys3 2>/dev/null
sudo mount -L transfer -o noexec,uid=1000,umask=0077 /mnt/transfer 2>/dev/null || sudo rmdir /mnt/transfer 2>/dev/null
if findmnt /lib/live/mount/medium 2>&1 | grep -e "/dev/sr0" >/dev/null ; then true; else
    sudo mkdir -p /media/cdrom
    sudo mount /dev/sr0 -o noexec,ro /media/cdrom 2>/dev/null || sudo rmdir /media/cdrom 2>/dev/null
fi
for KEY_LOCATION in /mnt/keys1 /mnt/keys2 /mnt/keys3 /media/cdrom ; do
    if [ -e $KEY_LOCATION/keys ] ; then
        echo "Key found at: $KEY_LOCATION/keys"
        diff -qr $KEY_LOCATION/keys/1 $KEY_LOCATION/keys/2 || echo "$KEY_LOCATION/keys/1 $KEY_LOCATION/keys/2 inconsistent"
        diff -qr $KEY_LOCATION/keys/1/private-keys-v1.d $KEY_LOCATION/keys/bak/private-keys-v1.d || echo "$KEY_LOCATION/keys/1 $KEY_LOCATION/keys/bak private keys mismatch"
        if [ -e ~/.gnupg ] ; then
            diff -qr $KEY_LOCATION/keys/1 ~/.gnupg
        else
            cp -r $KEY_LOCATION/keys/1 -T ~/.gnupg
        fi
        if [ -e $KEY_LOCATION/integrity_check ] ; then
            if [ -e ~/integrity_check ] ; then true; else
                cp -r $KEY_LOCATION/integrity_check -T ~/integrity_check
            fi
        fi
    fi
done
if [ -e ~/.gnupg ] ; then true; else
    echo "No keys found, to create a new key see generate_key.sh"
fi
