#!/usr/bin/python3
#If necessary, this can be bypassed by directly calling /sbin/shutdown (be aware this leaves ~/.gnupg in memory)
#but if one medium actually is bad, unmounting and removing just that one will allow writing the rest
import os
import subprocess
import sys
import glob
key_locations=[f for f in ['/mnt/keys1/keys/','/mnt/keys2/keys/','/mnt/keys3/keys/','/media/cdrom0/keys/'] if os.path.exists(f)]
key_devices=[subprocess.run(["findmnt","-n","-o","SOURCE","-T",f],check=True,stdout=subprocess.PIPE).stdout.rstrip() for f in key_locations]
running_key_location='/home/user/.gnupg'
if subprocess.run(["python3","/usr/local/bin/write_keys.py","-y"]).returncode!=0:
    print("Remove key media and run this again (they are unmounted if there wasn't an error - this message is to prevent accidents)")
    sys.exit(1)
a=None
is_toram=b'/dev/sr0' not in subprocess.run(["findmnt","/lib/live/mount/medium"],stdout=subprocess.PIPE,stderr=subprocess.STDOUT).stdout
while True:
    remaining_media=[key_locations[n] for n in range(len(key_locations)) if os.path.exists(key_devices[n])]
    if remaining_media:
        print("Remove key media "+str(remaining_media)+" before proceeding")
    if '/media/cdrom0/keys/' in remaining_media:
        if subprocess.run(["sudo","eject",'/media/cdrom0']).returncode==0:
            remaining_media.remove('/media/cdrom0/keys/')
    if is_toram:
        subprocess.run(["sudo","eject",'/dev/sr0'],stderr=subprocess.PIPE)#a newly-written keys CD might not be mounted
    if not remaining_media and a is not None:
        break
    a=input("Wipe memory?(y/n)")
subprocess.run(["sudo","umount","-a"],stderr=subprocess.PIPE)#some are expected to fail - hide the errors
if a=='n':
    subprocess.run(["sudo","/sbin/shutdown"]+(['-P','now'] if len(sys.argv)<=1 else sys.argv[1:]))
    sys.exit(0)#in case this is a delayed shutdown
junkfile="/tmp/junkfillspace"
try:
    with open(junkfile,"wb") as f:
        n=0
        while True:
            print("file {}MiB".format(256*n))
            n=n+1
            for n2 in range(256*1024):
                f.write(os.urandom(1024))
except Exception:
    pass
try:
    a=[]
    n=0
    while True:
        print("mem {}MiB".format(256*n))
        n=n+1
        for n2 in range(1):
            a.append(os.urandom(256*1024*1024))#using a large block to mostly get a MemoryError rather than a hang (without toram)/OOM kill (with toram)
except Exception:
    del a
subprocess.run(["sudo","/sbin/shutdown"]+(['-P','now'] if len(sys.argv)<=1 else sys.argv[1:]))
