#!/usr/bin/python3
import sys
import subprocess
import os.path
import scipy.io.wavfile
import numpy as np
#record some keyboard sound, if this hasn't already been done
if not os.path.exists(sys.argv[1]+"/config/misc_source/orig_keysound.wav"):
    input("orig_keysound.wav not found: press Enter, then randomly type fast until the next message appears (15 seconds)")
    subprocess.run(["arecord","-f","cd","-d","15",sys.argv[1]+"/config/misc_source/orig_keysound.wav"])
    print("recording finished")
rate,arr1=scipy.io.wavfile.read(sys.argv[1]+"/config/misc_source/orig_keysound.wav")
arr1=arr1.astype(np.float64)
arr1=arr1-arr1.mean()
final_length=2*rate
active_fraction=(np.abs(arr1)>arr1.std()).mean()
active_amplitude=arr1.std()/active_fraction
num_layers=int(6/active_fraction)#enough times to give ~continuous sound
start_points=(np.random.rand(num_layers)*(arr1.shape[0]-final_length)).astype(int)
arr2=sum([arr1[p:p+final_length,:] for p in start_points])#make time-shifted copies
arr2=arr2*(20000/np.percentile(arr2,99.9))+5000*np.random.randn(*arr2.shape)#combine them, and add some white noise to make sure there are no gaps
scipy.io.wavfile.write(sys.argv[1]+"/config/includes.chroot/usr/local/share/keysound.wav",rate,arr2.astype(np.int16))
